<template>
  <div class="row">
    <div class="col-md-12">
      <transition name="fade">
        <div v-if="paginationData">
          <b-pagination
            v-model="currentPage"
            :total-rows="paginationData.total"
            :per-page="paginationData.per_page"
            @change="getTickets"
          ></b-pagination>

          <table class="table table-active mb-3">
            <thead class="table-dark">
              <tr>
                <th scope="col"></th>
                <th scope="col">{{ $t("name") }}</th>
                <th scope="col">{{ $t("status") }}</th>
              </tr>
            </thead>
            <tbody>
              <tr v-for="ticket in tickets" :key="ticket.id">
                <th scope="row" class="align-middle">
                  <router-link
                    :to="{
                      name: 'panel.tickets.get',
                      params: { id: ticket.id }
                    }"
                    class="btn btn-outline-info btn-sm"
                  >
                    {{ $t("view") }}
                  </router-link>
                </th>
                <td class="align-middle">
                  {{ ticket.name }}
                </td>
                <td class="align-middle">
                  <h6>
                    <span v-if="ticket.closed_at" class="badge badge-danger">{{
                      $t("status_closed")
                    }}</span>
                    <span
                      v-if="
                        ticket.last_reply_by == user.id && !ticket.closed_at
                      "
                      class="badge badge-success"
                      >{{ $t("status_waiting") }}</span
                    >
                    <span
                      v-if="
                        ticket.last_reply_by != user.id && !ticket.closed_at
                      "
                      class="badge badge-warning"
                      >{{ $t("status_replied") }}</span
                    >
                  </h6>
                </td>
              </tr>
            </tbody>
          </table>

          <b-pagination
            v-model="currentPage"
            :total-rows="paginationData.total"
            :per-page="paginationData.per_page"
            @change="getTickets"
          ></b-pagination>

          <router-link
            :to="{
              name: 'panel.tickets.create'
            }"
            class="btn btn-info"
          >
            {{ $t("create_ticket") }}
          </router-link>
        </div>
      </transition>
    </div>
  </div>
</template>

<script>
import Form from "vform";
import { mapGetters } from "vuex";
import axios from "axios";

export default {
  scrollToTop: false,

  metaInfo() {
    return { title: this.$t("tickets") };
  },

  data: () => ({
    paginationData: null,
    currentPage: 1
  }),

  mounted() {
    this.getTickets();
  },

  computed: {
    ...mapGetters({
      user: "auth/user"
    }),
    tickets() {
      return this.paginationData.data;
    }
  },

  methods: {
    async getTickets(page = 1) {
      const { data } = await axios.get(
        route("shop.tickets.index") + "?page=" + page
      );
      if (data) {
        this.paginationData = data;
      }
    }
  }
};
</script>
